#include "calculations_milky_way.h"


double
*picplanner_get_coordinates_rotational_milky_way (void)
{
  double *coordinates = malloc (sizeof (double) * 2);
  double right_ascension = 266.417;
  double declination = -29.008;
  /* Coordinates are nearly fixed compared to the non rotating coordinate system of the earth.
   * Values taken from Wikipedia? TODO*/

  coordinates[0] = right_ascension;
  coordinates[1] = declination;

  return coordinates;
}


double
*picplanner_get_coordinates_milky_way (GDateTime *date_time,
                                       double longitude,
                                       double latitude)
{
  double siderial_time;
  double *coordinates_milky_way;
  double *coordinates_horizontal_milky_way = malloc (sizeof (double) * 2 * 288);

  coordinates_milky_way = picplanner_get_coordinates_rotational_milky_way ();
  siderial_time = time_jd_to_sidereal_time (longitude, date_time);
  coordinates_horizontal_milky_way = picplanner_transform_rotational_to_horizontal(coordinates_milky_way,
                                                                                   latitude,
                                                                                   siderial_time);

  return coordinates_horizontal_milky_way;
}


double
*picplanner_get_array_coordinates_milky_way (GDateTime *date_time,
                                             double longitude,
                                             double latitude)
{
  GDateTime *iteration_time;
  double *coordinates_milky_way;
  double *array_coordinates_milky_way = malloc (sizeof (double) * 2 * NUM_DATA_POINTS);

  iteration_time = g_date_time_add_hours (date_time, -12);

  for (int i=0; i<NUM_DATA_POINTS; i++)
    {
      coordinates_milky_way = picplanner_get_coordinates_milky_way (iteration_time,
                                                                    longitude,
                                                                    latitude);
      array_coordinates_milky_way[2*i] = coordinates_milky_way[0];
      array_coordinates_milky_way[2*i+1] = coordinates_milky_way[1];
      iteration_time = g_date_time_add_minutes (iteration_time, 24*60/NUM_DATA_POINTS);
    }

  g_print ("Milky Way: Azimuth now: %f, Elevation now: %f\n",
           array_coordinates_milky_way[144*2],
           array_coordinates_milky_way[144*2+1]);

  return array_coordinates_milky_way;
}
